$nocompile

$lib "i2c_twi.lbx"                                          ' biblioteka obsugujca hardwarowe TWI
Config Sda = Portc.1
Config Scl = Portc.0
Config Twi = 100000                                         ' 100KHz
I2cinit
'-------------------------------------------------------------------------------
'zmienne
Dim Second As Byte
Dim Minute As Byte
Dim Hour As Byte
Dim Day As Byte
Dim Month As Byte
Dim Year As Word
Dim Weekday As Byte

Dim Year_ As Word
Dim Month_ As Byte
Dim Day_ As Byte
Dim Minute_ As Byte
Dim Hour_ As Byte

Dim Blad As Byte                                            'kody bledow zwracane przez funkcje
Dim Old_minute As Byte
Dim Time_string As String * 20


'Declare Sub Displaytime()
' stae

' konfiguracja bufora -> jeeli tylko bufor dla zegara to 0, jeeli bufor dla zegara i alarmu to 1
' domylnie 0 - bufor tylko dla zegara

Const _clock_alarm = 0

' adresy ukadu PCF8583
' jeeli noga A0 ukad PCF8583 jest podczony do GND to:
' adres do odczytu = &HA1
' adres do zapisu = &HA0
' jeeli noga A0 ukad PCF8583 jest podczony do VCC to:
' adres do odczytu = &HA3
' adres do zapisu = = &HA2

Const Pcf8583r = &HA3
Const Pcf8583w = &HA2

' dugo bufora

#if _clock_alarm = 0
   Const Pcf8583_bufor_len = 8
#else
   Const Pcf8583_bufor_len = 16
#endif

' adresy rejestrw

' mapa pamici ukadu PCF8583 - opis na str. 8
' od adresu 16 (hex &H10) jest wolne 240 (hex &HF0) bajtw pamici RAM

Const Pcf8583_control = 0
Const Pcf8583_100th_of_a_second = 1
Const Pcf8583_seconds = 2
Const Pcf8583_minutes = 3
Const Pcf8583_hours = 4
Const Pcf8583_year_date = 5
Const Pcf8583_weekdays_months = 6
Const Pcf8583_timer = 7

#if _clock_alarm = 1

   Const Pcf8583_alarm_control = 8
   Const Pcf8583_alarm_100th_of_a_second = 9
   Const Pcf8583_alarm_seconds = 10
   Const Pcf8583_alarm_minutes = 11
   Const Pcf8583_alarm_hours = 12
   Const Pcf8583_alarm_date = 13
   Const Pcf8583_alarm_months = 14
   Const Pcf8583_alarm_timer = 15

#endif

Const Pcf8583_free_ram = 16                                 ' od tego adresu jest 240 bajtw wolnego ramu

' ID danych

Const Rok_id = &H55AA                                       ' przypadkowa warto ktra wpada mi do ba :)

'-------------------------------------------------------------------------------
' zmienne globalne

   Dim Rtc_bufor(pcf8583_bufor_len) As Byte

   Dim Rtc_control As Byte At Rtc_bufor + Pcf8583_control Overlay       ' Control and status register - opis poszczeglnych bitw na str. 6
   Dim Rtc_100th_of_a_second As Byte At Rtc_bufor + Pcf8583_100th_of_a_second Overlay
   Dim Rtc_seconds As Byte At Rtc_bufor + Pcf8583_seconds Overlay
   Dim Rtc_minutes As Byte At Rtc_bufor + Pcf8583_minutes Overlay
   Dim Rtc_hours As Byte At Rtc_bufor + Pcf8583_hours Overlay
   Dim Rtc_year_date As Byte At Rtc_bufor + Pcf8583_year_date Overlay
   Dim Rtc_weekdays_months As Byte At Rtc_bufor + Pcf8583_weekdays_months Overlay
   Dim Rtc_timer As Byte At Rtc_bufor + Pcf8583_timer Overlay

#if _clock_alarm = 1

   Dim Rtc_alarm_control As Byte At Rtc_bufor + Pcf8583_alarm_control Overlay       ' Alarm control registers, clock mode - opis poszczeglnych bitw na str. 10
   Dim Rtc_alarm_100th_of_a_second As Byte At Rtc_bufor + Pcf8583_alarm_100th_of_a_second Overlay
   Dim Rtc_alarm_seconds As Byte At Rtc_bufor + Pcf8583_alarm_seconds Overlay
   Dim Rtc_alarm_minutes As Byte At Rtc_bufor + Pcf8583_alarm_minutes Overlay
   Dim Rtc_alarm_hours As Byte At Rtc_bufor + Pcf8583_alarm_hours Overlay
   Dim Rtc_alarm_date As Byte At Rtc_bufor + Pcf8583_alarm_date Overlay
   Dim Rtc_alarm_months As Byte At Rtc_bufor + Pcf8583_alarm_months Overlay
   Dim Rtc_alarm_timer As Byte At Rtc_bufor + Pcf8583_alarm_timer Overlay

#endif

' ukad PCF8583 posiada czteroletni kalendarz, od adresu 16 (hex &H10) w pamici ukadu
' bd zapisywane dane potrzebne do obliczenia aktualnego roku
' aktualny rok = kalendarz baza + warto z czteroletniego kalendarza

   Dim Pcf8583_dane_bufor(7) As Byte

   Dim Pcf8583_data_id As Word At Pcf8583_dane_bufor Overlay       ' id danych &H55AA (word)
   Dim Pcf8583_kalendarz_baza As Word At Pcf8583_dane_bufor + 2 Overlay       ' baza 2000, 2004, 2008 ... wielokrotno 4 letniego kalendarza (word)
   Dim Pcf8583_year_old As Byte At Pcf8583_dane_bufor + 4 Overlay       ' stara warto od 0 do 3 (byte) kalendarza czteroletniego (obliczona warto z Pcf8583_year_date)
   Dim Pcf8583_crc16 As Word At Pcf8583_dane_bufor + 5 Overlay       ' suma kontrolna (word) danych: id, kalendarz_baza i year_old (Pcf8583_crc16 = Crc16(Pcf8583_dane_bufor(1) , 5))

'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
' deklaracje funkcji

' Funkcja odczytuje godzin i dat z ukad PCF8583 i zapisuje w zmiennych
' globalnych:  Hour (byte), Minute (byte),  Second (byte), Day (byte),
' Month (byte), Year (word), Weekday (byte).
' funkcja zwraca:
' 0 - ok
' 1 - bad magistrali I2C
' 2 - uszkodzone dane w pamici RAM ukadu PCF8583 (dane potrzebne do obliczenia aktualnego roku)

'Declare Function Pcf8583_gettime() As Byte


' Funkcja zapisuje godzin i dat do ukadu PCF8583. Dzie tygodnia jest obliczany
' automatycznie na podstawie daty.
' wejcie: sekundy, minuty, godziny, dzie, miesic i rok
' funkcja zwraca:
' 0 - ok
' 1 - bd I2C

'Declare Function Pcf8583_storetime(byval S As Byte , Byval M As Byte , Byval H As Byte , Byval D As Byte , Byval Mm As Byte , Byval Y As Word) As Byte


' Funkcja odczytuje okrelon ilo danych z ukadu Pcf8583.
' wejcie:
' bufor - tablica w ktrej maj by zapisane dane.
' adres - adres ram ukadu Pcf8583 od ktrego zaczyna si odczyt
' ilosc_bajtow - ilo danych do odczytu
' funkcja zwraca:
' 0 = ok, 1 = bd I2C

'#if _build < 20760
   'Declare Function Pcf8583_read(byref Bufor As Byte , Byval Adres As Byte , Byval Ilosc_bajtow As Byte) As Byte
'#else
   'Declare Function Pcf8583_read(byref Bufor() As Byte , Byval Adres As Byte , Byval Ilosc_bajtow As Byte) As Byte
'#endif

' Funkcja zapisuje okrelon ilo danych do ukadu Pcf8583.
' wejcie:
' bufor - tablica z ktrej maj by pobierane dane do zapisu
' adres - adres ram ukadu Pcf8583 od ktrego zaczyna si zapis
' ilosc_bajtow - ilo danych do zapisu
' funkcja zwraca:
' 0 = ok, 1 = bd I2C

'#if _build < 20760
'   Declare Function Pcf8583_write(byref Bufor As Byte , Byval Adres As Byte , Byval Ilosc_bajtow As Byte) As Byte
'#else
'   Declare Function Pcf8583_write(byref Bufor() As Byte , Byval Adres As Byte , Byval Ilosc_bajtow As Byte) As Byte
'#endif

' Funkcja zapisuje w PCF8583 dane potrzebne do obliczenia aktualnym roku
' (PCF8583 posiada tylko czteroletni kalendarz). Zapisywane s takie dane:
' ID (word), baza kalendarza (word), warto kalendarza czteroletniego (byte)
' i suma kontrolna (word) - cao 7 bajtw
' wejcie: - rok (word)
' funkcja zwraca:  0 - ok, 1 - bd I2C

'Declare Function Pcf8583_store_year(byval Year As Word) As Byte


' Funkcja sprawdza czy dane potrzebne do obliczenia aktualnego roku,
' zawarte w tablicy globalnej Pcf8583_dane_bufor() nie s uszkodzone.
' Sprawdzany jest id i suma kontrolna. Dane do bufora naley wczeniej
' odczyta funkcj Pcf8583_read().
' funkcja zwraca: 0 = ok, 1 = bd

'Declare Function Pcf8583_sprawdz_dane() As Byte


' Funkcja oblicza na podstawie daty jaki jest dzie tygodnia. Funkcje napisano
' na podstawie przykadu w Pascalu ze strony http://pl.wikipedia.org/wiki/Kalendarz_wieczny
'
' Wejcie:
' - dzien , miesic , rok
'
' Wyjcie:
' 0 - niedziela
' 1 - poniedziaek
' 2 - wtorek
' 3 - roda
' 4 - czwartek
' 5 - pitek
' 6 - sobota

'Declare Function Oblicz_dzien_tygodnia(day As Byte , Month As Byte , Year As Word) As Byte

'-------------------------------------------------------------------------------

'*******************************************************************************
'*
'*   plik:    PCF8583.bas
'*   wersja:  1.0
'*
'*   autor:   Tomasz Sadzikowski (mundi1970@gmail.com)
'*   data:    24.01.2013
'*
'*   kompilator: BASCOM Version 2.0.7.6.001
'*
'*   UWAGA!!! funkcje wykorzystuj 7 bajtw pamici ram ukadu PCF8583
'*   Od adresu 0x10 zaczyna si 240 bajtw wolnej pamici ram. Pierwsze
'*   7 bajtw wykorzystane, pozostaa cz jest wolna.
'*
'*   UWAGA!!! zmienne  globalne Hour (byte), Minute (byte), Second (byte),
'*   Day (byte), Month (byte), Year (word), Weekday (byte), nie s zdefiniowane
'*
'*   UWAGA!!! plik Config_PCF8583.bas jest powizany z plikiem PCF8583.bas
'*   Sposb doczania plikw do wasnego programu:
'*
'*      $include "Config_PCF8583.bas"
'*
'*      Dim ....
'*
'*      Do
'*      .......
'*      Loop
'*      End
'*
'*      $include "PCF8583.bas"
'*
'*******************************************************************************


' Funkcja odczytuje godzin i dat z ukad PCF8583 i zapisuje w zmiennych
' globalnych:  Hour (byte), Minute (byte),  Second (byte), Day (byte),
' Month (byte), Year (word), Weekday (byte).
' funkcja zwraca:
' 0 - ok
' 1 - bad magistrali I2C
' 2 - uszkodzone dane w pamici RAM ukadu PCF8583 (dane potrzebne do obliczenia aktualnego roku)

Function Pcf8583_gettime() As Byte

   Local Temp_b As Byte , Error As Byte

   Error = Pcf8583_read(rtc_bufor(3) , Pcf8583_seconds , 5) ' odczytaj 5 bajtw od adresu 0x02, i zapisz do tablicy zaczynajcej si od rtc_seconds (rtc_bufor(3))
   If Error = 0 Then                                        ' jeeli nie byo bdu
      Error = Pcf8583_read(pcf8583_dane_bufor(1) , Pcf8583_free_ram , 7)       ' odczytaj 7 bajtw od adresu 0x10 (dec 16), i zapisz do tablicy zaczynajcej si od pcf8583_dane_bufor(1)
      If Error = 0 Then                                     ' jeeli nie byo bdu
         Error = Pcf8583_sprawdz_dane()                     ' sprawd czy dane w pamici RAM ukadu PCF8583 nie s uszkodzone
         If Error = 0 Then                                  ' jeeli nie byo bdu

            Second = Makedec(rtc_seconds)                   ' sekundy
            Minute = Makedec(rtc_minutes)                   ' minuty
            Hour = Makedec(rtc_hours)                       ' godziny

            Temp_b = Rtc_year_date                          ' rok
            Shift Temp_b , Right , 6
            Temp_b = Makedec(temp_b)
            Year = Pcf8583_kalendarz_baza + Temp_b          '  baza + warto kalendarza czteroletniego

            If Temp_b <> Pcf8583_year_old Then              ' jeeli zmieni si rok
               If Temp_b = 0 And Pcf8583_year_old = 3 Then  ' jeeli skoczy si kalendarz czteroletni
                  Year = Year + 4                           ' zmie baz kalendarza
               End If
               Error = Pcf8583_store_year(year)             ' zapisz dane o aktualnym roku w ukadzie PCF8583
            End If

            Temp_b = Rtc_year_date And &B0011_1111          ' dzie
            Day = Makedec(temp_b)

            Temp_b = Rtc_weekdays_months                    ' dzie tygodnia
            Shift Temp_b , Right , 5
            Weekday = Makedec(temp_b)

            Temp_b = Rtc_weekdays_months And &B0001_1111    ' miesic
            Month = Makedec(temp_b)
         Else
           Error = 2                                        ' 2 - uszkodzone dane w pamici RAM
         End If
      End If
   End If

   Pcf8583_gettime = Error                                  ' funkcja zwraca 0 - ok, 1 - bd I2C, 2 - uszkodzone dane w pamici RAM

End Function

'-------------------------------------------------------------------------------
' Funkcja zapisuje godzin i dat do ukadu PCF8583. Dzie tygodnia jest obliczany
' automatycznie na podstawie daty.
' wejcie: sekundy, minuty, godziny, dzie, miesic i rok
' funkcja zwraca:
' 0 - ok
' 1 - bd I2C

Function Pcf8583_storetime(byval S As Byte , Byval M As Byte , Byval H As Byte , Byval D As Byte , Byval Mm As Byte , Byval Y As Word) As Byte

   Local Temp_b As Byte , Error As Byte

   Rtc_seconds = Makebcd(s)                                 ' sekundy
   Rtc_minutes = Makebcd(m)                                 ' minuty
   Rtc_hours = Makebcd(h)                                   ' godziny

   Rtc_year_date = Makebcd(d)                               ' dzie i rok
   Temp_b = Y Mod 4
   Temp_b = Makebcd(temp_b)
   Shift Temp_b , Left , 6
   Rtc_year_date = Rtc_year_date Or Temp_b

   Rtc_weekdays_months = Makebcd(mm)                        ' dzie tygodnia i miesic
   Temp_b = Oblicz_dzien_tygodnia(d , Mm , Y)               ' na podstawie daty oblicz dzie tygodnia
   Temp_b = Makebcd(temp_b)
   Shift Temp_b , Left , 5
   Rtc_weekdays_months = Rtc_weekdays_months Or Temp_b

   Error = Pcf8583_write(rtc_bufor(3) , Pcf8583_seconds , 5)       ' zapisz 5 bajtw od adresu 0x02, dane pobierz z tablicy zaczynajcej si od rtc_bufor(3)

   If Error = 0 Then                                        ' jeeli nie by bdu
      Error = Pcf8583_store_year(y)                         ' zapisz dane o aktualnym roku w ukadzie PCF8583
   End If

   Pcf8583_storetime = Error                                ' funkcja zwraca 0 - ok, 1 - bd I2C

End Function

'-------------------------------------------------------------------------------

' Funkcja odczytuje okrelon ilo danych z ukadu Pcf8583.
' wejcie:
' bufor - tablica w ktrej maj by zapisane dane.
' adres - adres ram ukadu Pcf8583 od ktrego zaczyna si odczyt
' ilosc_bajtow - ilo danych do odczytu
' funkcja zwraca:
' 0 = ok, 1 = bd I2C

Function Pcf8583_read(byref Bufor As Byte , Byval Adres As Byte , Byval Ilosc_bajtow As Byte) As Byte

   Local Dana As Byte , Index As Byte , Pozycja As Byte

   Index = 1
   Pozycja = 1                                              ' UWAGA!!! Jeeli Config Base = 0 to chyba powinno by :) Pozycja = 0

   I2cstart
   If Err = 0 Then                                          ' sprawd czy wystpi bd
      I2cwbyte Pcf8583w                                     ' wylij adres ukadu Pcf8583 tryb zapis
      If Err = 0 Then                                       ' sprawd czy wystpi bd
         I2cwbyte Adres                                     ' adres ram w Pcf8583 od ktrego zacznie si odczyt
         If Err = 0 Then                                    ' sprawd czy wystpi bd
            I2cstart
            I2cwbyte Pcf8583r                               ' wylij adres ukadu Pcf8583 tryb odczyt
            If Err = 0 Then                                 ' sprawd czy wystpi bd
               Do
                  If Index = Ilosc_bajtow Then              ' jeeli ostatni bajt to
                     I2crbyte Dana , Nack                   ' odczytaj bajt z Pcf8583  (NACK)
                  Else                                      ' jeeli nie to
                     I2crbyte Dana , Ack                    ' odczytaj bajt z Pcf8583 (ACK)
                  End If                                    ' odczytaj dan
                  Bufor(pozycja) = Dana                     ' zapisz w tablicy
                  Incr Pozycja                              ' zwiksz Pozycje o 1
                  Incr Index                                ' zwiksz Index o 1
               Loop Until Err = 1 Or Index > Ilosc_bajtow   ' opu ptle jeeli pobrano wszystkie dane lub wystpi bd
            End If
         End If
      End If
      I2cstop
   End If

   Pcf8583_read = Err                                       ' zwracany kod

End Function

'-------------------------------------------------------------------------------
' Funkcja zapisuje okrelon ilo danych do ukadu Pcf8583.
' wejcie:
' bufor - tablica z ktrej maj by pobierane dane do zapisu
' adres - adres ram ukadu Pcf8583 od ktrego zaczyna si zapis
' ilosc_bajtow - ilo danych do zapisu
' funkcja zwraca:
' 0 = ok, 1 = bd I2C

Function Pcf8583_write(byref Bufor As Byte , Byval Adres As Byte , Byval Ilosc_bajtow As Byte) As Byte

   Local Dana As Byte , Index As Byte , Pozycja As Byte

   Index = 1
   Pozycja = 1                                              ' UWAGA!!! Jeeli Config Base = 0 to chyba powinno by :) Pozycja = 0

   I2cstart
   If Err = 0 Then                                          ' sprawd czy wystpi bd
      I2cwbyte Pcf8583w                                     ' wylij adres ukadu Pcf8583 tryb zapis
      If Err = 0 Then                                       ' sprawd czy wystpi bd
         I2cwbyte Adres                                     ' wylij adres ram w Pcf8583 od ktrego zacznie si zapis
         If Err = 0 Then                                    ' sprawd czy wystpi bd
            Do
               Dana = Bufor(pozycja)                        ' odczytaj dan z tablicy
               I2cwbyte Dana                                ' i wylij dane do Pcf8583
               Incr Pozycja                                 ' zwiksz Pozycje o 1
               Incr Index                                   ' zwiksz Index o 1
            Loop Until Err = 1 Or Index > Ilosc_bajtow      ' opu ptle jeeli zapisano wszystkie dane lub wystpi bd
         End If
      End If
      I2cstop
   End If

   Pcf8583_write = Err                                      ' zwracany kod

End Function

'-------------------------------------------------------------------------------
' Funkcja zapisuje w PCF8583 dane potrzebne do obliczenia aktualnym roku
' (PCF8583 posiada tylko czteroletni kalendarz). Zapisywane s takie dane:
' ID (word), baza kalendarza (word), warto kalendarza czteroletniego (byte)
' i suma kontrolna (word) - cao 7 bajtw
' wejcie: - rok (word)
' funkcja zwraca:  0 - ok, 1 - bd I2C

Function Pcf8583_store_year(byval Year As Word) As Byte

   Local Temp_b As Byte

   Pcf8583_data_id = Rok_id                                 ' ID &H55AA
   Temp_b = Year Mod 4
   Pcf8583_year_old = Makebcd(temp_b)                       ' zapamitaj warto kalendarza czteroletniego (0-3)
   Pcf8583_kalendarz_baza = Year - Temp_b                   ' 2000, 2004, 2008 .....
   Pcf8583_crc16 = Crc16(pcf8583_dane_bufor(1) , 5)         ' oblicz sum kontroln danych

   Pcf8583_store_year = Pcf8583_write(pcf8583_dane_bufor(1) , Pcf8583_free_ram , 7)       ' zapisz 7 bajtw od adresu 0x10 (dec 16), dane pobierz z tablicy zaczynajcej si od pcf8583_dane_bufor(1)
                                                            ' funkcja zwraca 0 - ok, 1 - bd I2C
End Function

'-------------------------------------------------------------------------------
' Funkcja sprawdza czy dane potrzebne do obliczenia aktualnego roku,
' zawarte w tablicy globalnej Pcf8583_dane_bufor() nie s uszkodzone.
' Sprawdzany jest id i suma kontrolna. Dane do bufora naley wczeniej
' odczyta funkcj Pcf8583_read().
' funkcja zwraca: 0 = ok, 1 = bd

Function Pcf8583_sprawdz_dane() As Byte

   Local Crc As Word

   Pcf8583_sprawdz_dane = 1                                 ' bd dane uszkodzone

   Crc = Crc16(pcf8583_dane_bufor(1) , 5)                   ' oblicz sum kontroln Pcf8583_data_id,  Pcf8583_kalendarz_baza i Pcf8583_year_old
   If Crc = Pcf8583_crc16 Then                              ' sprawd czy suma kontrolna si zgadza
      If Pcf8583_data_id = Rok_id Then                      ' sprawd czy id (&H55AA) si zgadza
         Pcf8583_sprawdz_dane = 0                           ' brak bdu
      End If
   End If

End Function

'-------------------------------------------------------------------------------
' Funkcja oblicza na podstawie daty jaki jest dzie tygodnia. Funkcje napisano
' na podstawie przykadu w Pascalu ze strony http://pl.wikipedia.org/wiki/Kalendarz_wieczny
'
' Wejcie:
' - dzien , miesic , rok
'
' Wyjcie:
' 0 - niedziela
' 1 - poniedziaek
' 2 - wtorek
' 3 - roda
' 4 - czwartek
' 5 - pitek
' 6 - sobota

Function Oblicz_dzien_tygodnia(day As Byte , Month As Byte , Year As Word) As Byte

   Local M As Integer , C As Integer , D As Integer , N As Integer , Temp As Integer

   M = Month + 9 : M = M Mod 12 : M = M + 1 : If M > 10 Then Year = Year - 1
   C = Year \ 100 : D = Year Mod 100
   N = 13 * M : N = N - 1 : N = N \ 5 : N = N + D : Temp = D \ 4
   N = N + Temp : Temp = C \ 4 : N = N + Temp : Temp = 5 * C : N = N + Temp
   N = N + Day : N = N Mod 7

   Oblicz_dzien_tygodnia = N

End Function

Sub Displaytime()

   'Lcd Lookupstr(weekday , Weekdays) ; " "
   'If Day < 10 Then Lcd "0" : Lcd Day ; "-"
   'If Month < 10 Then Lcd "0" : Lcd Month ; "-" ; Year ; " "
   'If Hour < 10 Then Lcd "0" : Lcd Hour ; ":"
   'If Minute < 10 Then Lcd "0" : Lcd Minute                 ' ; ":"
   'If Second < 10 Then Lcd "0" : Lcd Second


   Time_string = Lookupstr(weekday , Weekdays) + " "

   If Day < 10 Then
    Time_string = Time_string + "0" + Str(day) + "-"
   Else
    Time_string = Time_string + Str(day) + "-"
   End If

   If Month < 10 Then
    Time_string = Time_string + "0" + Str(month) + "-" + Str(year) + " "
   Else
    Time_string = Time_string + Str(month) + "-" + Str(year) + " "
   End If

   If Hour < 10 Then
    Time_string = Time_string + "0" + Str(hour) + ":"
   Else
    Time_string = Time_string + Str(hour) + ":"
   End If

   If Minute < 10 Then
    Time_string = Time_string + "0" + Str(minute)
   Else
    Time_string = Time_string + Str(minute)
   End If

        Lcd Time_string


End Sub